AC_DEFUN([AC_GDS_CXX_HAS_IS_NOTHROW_MOVEABLE],[dnl
AC_LANG_PUSH([C++])
AC_COMPILE_IFELSE([AC_LANG_PROGRAM( [[
#include <algorithm>

struct gstruct
{
void Swap( gstruct& rhs );
};

namespace std {
template<>
inline void swap<>( gstruct& lhs, gstruct& rhs )
noexcept( __and_<is_nothrow_move_constructible< gstruct >,
is_nothrow_move_assignable< gstruct > >::value )
{
lhs.Swap( rhs );
}
}
]],[[]])],[AC_DEFINE([HAVE_IS_NOTHROW_MOVEABLE],[1],[Defined if swap needs __is_nothrow_move_constructible+assignable])
HAVE_IS_NOTHROW_MOVEABLE=1
],[HAVE_IS_NOTHROW_MOVEABLE=0])
AC_LANG_POP([C++])
AC_SUBST([HAVE_IS_NOTHROW_MOVEABLE])
])
